<?php if(!defined('SABLOG_ROOT')) exit('Access Denied');?>
{template header}

	<div id="page">
		<div id="wrap">
			<h3 class="title">高级搜索</h3>
			<form method="post" action="$options[url]post.php">
			<input type="hidden" name="formhash" value="$formhash" />
			<input type="hidden" name="action" value="search" />
			<table class="formbox">
				<tr>
					<td colspan="3">关键字:<br />
						<input required="ture" name="keywords" type="text" size="30" class="formfield" />
						关键字中可使用通配符 &quot;*&quot;
						<br /><br />
						匹配多个关键字全部, 可用空格或 &quot;AND&quot; 连接. 如 angel AND 4ngel<br />匹配多个关键字其中部分, 可用 &quot;|&quot; 或 &quot;OR&quot; 连接. 如 angel OR 4ngel</td>
				</tr>
				<tr>
					<td colspan="3"><hr /></td>
				</tr>
				<tr>
					<td valign="top">
					<fieldset>
						<legend>搜索分类</legend>
						<select name="mids[]" multiple="multiple" style="width:100%" size="8">
							<option value="" selected="selected">搜索所有分类</option>
							<!--{loop $catecache $data}-->
								<option value="$data[mid]">&nbsp;&nbsp;&#0124;-- $data[name]</option>
							<!--{/loop}-->
						</select>允许选择多个分类
					</fieldset>
					</td>
					<td>&nbsp;&nbsp;&nbsp;&nbsp;</td>
					<td valign="top">
					<fieldset>
						<legend>搜索方式</legend>
						<select name="searchin">
							<option value="title" selected="selected">标题搜索</option>
							<option value="content">全文搜索</option>
						</select>
					</fieldset>
					</td>
				</tr>
				<tr>
					<td colspan="3"><hr /></td>
				</tr>
				<tr>
					<td colspan="3"><button type="submit">确定</button></td>
				</tr>
			</table>
			</form>
		</div>
		<div id="sidebar">

			<!--{if $options['show_calendar']}-->
				<div id="showcalendar">
					<table cellpadding="0" cellspacing="1" style="width:100%">
						<tr>
							<td colspan="7" class="curdate"><a href="$prevmonth">&laquo;</a> $calendar[cur_date] <a href="$nextmonth">&raquo;</a></td>
						</tr>
						<tr>
							<th class="week"><span style="color:#833">日</span></th>
							<th class="week">一</th>
							<th class="week">二</th>
							<th class="week">三</th>
							<th class="week">四</th>
							<th class="week">五</th>
							<th class="week"><font color="#53A300">六</font></th>
						</tr>
						$calendar[html]
					</table>
				</div>
			<!--{/if}-->

			{template sidecomm}

			<!--{if $options['recentarticle_num']}-->
				<h4>最新文章</h4>
				<ul>
					<!--{if !$newarticlecache}-->
						<li>没有任何文章</li>
					<!--{else}-->
						<!--{loop $newarticlecache $data}-->
						<li><a href="$data[article_url]" title="$data[title]">$data[trimmed_title]</a></li>
						<!--{/loop}-->
					<!--{/if}-->
				</ul>
			<!--{/if}-->

			<!--{if $archivecache}-->
				<h4>归档</h4>
				<ul>
					<!--{loop $archivecache $key $data}-->
						<li><a href="$data[url]">$key</a> <span>($data[num])</span></li>
					<!--{/loop}-->
					<!--{if $archivenum > 12}-->
						<li><a href="$archives_url">更多...</a></li>
					<!--{/if}-->
				</ul>
			<!--{/if}-->

			<h4>其他</h4>
			<ul>
				<!--{if $options['rss_enable']}-->
				<li><a href="$options[url]rss.php">RSS 2.0</a></li>
				<!--{/if}-->
				<!--{if $options['wap_enable']}-->
				<li><a href="$options[url]wap/">WAP</a></li>
				<!--{/if}-->
				<li><a href="http://validator.w3.org/check?uri=referer" target="_blank">HTML 5</a></li>
				<!--{if $options['icp']}-->
				<li><a href="http://www.miibeian.gov.cn/" target="_blank">$options[icp]</a></li>
				<!--{/if}-->
			</ul>

		</div>
	</div>