<?php
// ========================== 文件说明 ==========================//
// 本文件说明：前台全部评论模块
// --------------------------------------------------------------//
// 本程序作者：angel
// --------------------------------------------------------------//
// 本程序版本：SaBlog-X Ver 2.0
// --------------------------------------------------------------//
// 本程序主页：http://www.sablog.net
// ==============================================================//

if(!defined('SABLOG_ROOT')) {
	exit('Access Denied');
}

if (!$options['show_all_comment']) {
	message('未开启查看所有评论功能.', './');
}

if ($stats['comment_count']) {
	$commentlist_num = intval($options['commentlist_num']);
	if($page) {
		$start_limit = ($page - 1) * $commentlist_num;
	} else {
		$start_limit = 0;
		$page = 1;
	}
	$multipage = multi($stats['comment_count'], $commentlist_num, $page, $comments_url, $maxpages);
	$query = $DB->query("SELECT 
	c.articleid,c.author,c.email,c.url,c.dateline,c.content,a.alias,a.title
	FROM {$db_prefix}comments c
	LEFT JOIN {$db_prefix}articles a ON a.articleid = c.articleid
	WHERE a.visible='1' AND c.visible='1' ORDER BY dateline DESC LIMIT $start_limit, $commentlist_num");

	$commentdb=array();
	while ($comment=$DB->fetch_array($query)) {
		$comment['article_url'] = getpermalink($comment['articleid'], $comment['alias']);
		$comment['avatardb'] = get_avatar($comment['email']);
		$comment['content'] = html_clean($comment['content']);
		$comment['dateline'] = sadate($options['comment_timeformat'], $comment['dateline'],1);
		$commentdb[]=$comment;
	}
	unset($comment);
	$DB->free_result($query);
}
$pagefile = 'comments';
$options['title'] = settitle('全部评论');

?>