<?php
// ========================== 文件说明 ==========================//
// 本文件说明：生成原始数据表结构记录文件
// --------------------------------------------------------------//
// 本程序作者：angel
// --------------------------------------------------------------//
// 本程序版本：SaBlog-X Ver 2.0
// --------------------------------------------------------------//
// 本程序主页：http://www.sablog.net
// ==============================================================//

require_once('../include/common.inc.php');

//生成数据库校验原文件
$tables = array(
	'articles',
	'attachments',
	'relationships',
	'comments',
	'links',
	'searchindex',
	'settings',
	'sessions',
	'statistics',
	'stylevars',
	'metas',
	'users'
);

$saxdb = array();
foreach ($tables as $table) {
	$fields = $DB->query("SHOW FIELDS FROM $db_prefix$table", 'SILENT');
	while ($field = $DB->fetch_array($fields)) {
		$saxdb[0][0][$table][$field['Field']]['Field'] = $field['Field'];
		$saxdb[0][0][$table][$field['Field']]['Type'] = $field['Type'];
		$saxdb[0][0][$table][$field['Field']]['Null'] = $field['Null'] == '' ? 'NO' : $field['Null'];
		$saxdb[0][0][$table][$field['Field']]['Extra'] = $field['Extra'];
		$saxdb[0][0][$table][$field['Field']]['Default'] = $field['Default'] == '' || $field['Default'] == '0' ? '' : $field['Default'];
	}
	ksort($saxdb[0][0][$table]);
	$DB->free_result($fields);
}

//这里是设置的记录
$saxdb[1] = array(
	'name',
	'url',
	'description',
	'icp',
	'templatename',
	'article_order',
	'show_all_comment',
	'related_shownum',
	'related_title_limit',
	'use_html',
	'show_calendar',
	'show_categories',
	'hottags_shownum',
	'show_archives',
	'recentcomment_num',
	'recentcomment_limit',
	'show_statistics',
	'show_debug',
	'audit_comment',
	'seccode',
	'comment_order',
	'article_comment_num',
	'comment_min_len',
	'comment_max_len',
	'commentlist_num',
	'comment_post_space',
	'seccode_adulterate',
	'attachments_dir',
	'attachments_save_dir',
	'attachments_thumbs',
	'attachments_thumbs_size',
	'display_attach',
	'remote_open',
	'watermark',
	'watermark_size',
	'waterpos',
	'watermarktrans',
	'pos_padding',
	'server_timezone',
	'comment_timeformat',
	'recent_comment_timeformat',
	'close',
	'close_note',
	'gzipcompress',
	'showmsg',
	'closereg',
	'censoruser',
	'enable_trackback',
	'audit_trackback',
	'trackback_life',
	'seccode_angle',
	'seccode_ttf',
	'title_keywords',
	'meta_keywords',
	'meta_description',
	'wap_article_limit',
	'wap_enable',
	'banip_enable',
	'ban_ip',
	'spam_enable',
	'spam_words',
	'spam_url_num',
	'spam_content_size',
	'tb_spam_level',
	'rss_enable',
	'rss_num',
	'rss_ttl',
	'permalink',
	'close_comment',
	'rss_all_output',
	'sitemap',
	'recentarticle_num',
	'recentarticle_limit',
	'maxpages',
	'show_n_p_title',
	'seccode_color',
	'seccode_size',
	'seccode_shadow',
	'article_shownum',
	'dateconvert',
	'article_timeformat',
	'show_avatar',
	'avatar_size',
	'avatar_level'
);

//pr($saxdb);

writefile(SABLOG_ROOT.'tools/saxdb.md5', md5(serialize($saxdb[0][0])).' *'.serialize($saxdb));

?>