<?php
@set_time_limit(0);
define('SABLOG_ROOT', dirname(__FILE__));
$onoff = function_exists('ini_get') ? ini_get('register_globals') : get_cfg_var('register_globals');
if ($onoff != 1) {
	@extract($_POST, EXTR_SKIP);
	@extract($_GET, EXTR_SKIP);
}
$php_self = $_SERVER['PHP_SELF'] ? $_SERVER['PHP_SELF'] : $_SERVER['SCRIPT_NAME'];

require_once('../include/func/global.func.php');


function runquery($sql) {
	global $db_prefix, $DB, $tablenum;

	$sql = str_replace("\r", "\n", str_replace(' sablog_', ' '.$db_prefix, $sql));
	$ret = array();
	$num = 0;
	foreach(explode(";\n", trim($sql)) as $query) {
		$queries = explode("\n", trim($query));
		foreach($queries as $query) {
			$ret[$num] .= $query[0] == '#' ? '' : $query;
		}
		$num++;
	}
	unset($sql);

	foreach($ret as $query) {
		$query = trim($query);
		if($query) {
			if(substr($query, 0, 12) == 'CREATE TABLE') {
				$name = preg_replace("/CREATE TABLE ([a-z0-9_]+) .*/is", "\\1", $query);
				echo '创建表 '.$name.' ... <font color="#0000EE">成功</font><br />';
				$DB->query(createtable($query));
				$tablenum++;
			} else {
				$DB->query($query);
			}
		}
	}
}
function createtable($sql) {
	$type = strtoupper(preg_replace("/^\s*CREATE TABLE\s+.+\s+\(.+?\).*(ENGINE|TYPE)\s*=\s*([a-z]+?).*$/isU", "\\2", $sql));
	$type = in_array($type, array('MYISAM', 'HEAP')) ? $type : 'MYISAM';
	return preg_replace("/^\s*(CREATE TABLE\s+.+\s+\(.+?\)).*$/isU", "\\1", $sql).
		(mysql_get_server_info() > '4.1' ? " ENGINE=$type DEFAULT CHARSET=utf8" : " TYPE=$type");
}

if ($action == 'first' || $action == 'second' || $action == 'three') {
	// 允许程序在 register_globals = off 的环境下工作
	// 加载数据库配置信息
	require_once('../config.php');
	// 加载数据库类
	require_once('../include/class/mysql.class.php');
	// 初始化数据库类
	$DB = new DB_MySQL;
	$DB->connect($servername, $dbusername, $dbpassword, $dbname, $usepconnect);
	unset($servername, $dbusername, $dbpassword, $dbname, $usepconnect);

	$step = (!$step) ? 1 : $step;
	$a = (!$a) ? 0 : $a;
	$percount = ($percount <= 0) ? 200 : $percount;
	$start    = ($step - 1) * $percount;
	$next     = $start + $percount;
	$step++;
	$jumpurl = $php_self.'?action='.$action.'&step='.$step.'&percount='.$percount;
	$goon = 0;
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>SABLOG-X | Powered by 4ngel</title>
<link href="install.css" rel="stylesheet" type="text/css" />
</head>
<body>
<?php
if ($action == 'first') {
$add = <<<EOT
DROP TABLE IF EXISTS {$db_prefix}metas;
CREATE TABLE {$db_prefix}metas (
mid mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
name varchar(100) NOT NULL DEFAULT '',
slug varchar(200) NOT NULL,
type enum('category','tag','link_category') NOT NULL,
description varchar(200) NOT NULL DEFAULT '',
count smallint(6) unsigned NOT NULL DEFAULT '0',
displayorder smallint(6) unsigned NOT NULL DEFAULT '0',
PRIMARY KEY (mid),
KEY slug (slug),
KEY displayorder (displayorder)
) ENGINE=MyISAM ;


DROP TABLE IF EXISTS {$db_prefix}relationships;
CREATE TABLE {$db_prefix}relationships (
cid mediumint(8) unsigned NOT NULL DEFAULT '0',
mid mediumint(8) unsigned NOT NULL DEFAULT '0',
PRIMARY KEY (cid,mid)
) ENGINE=MyISAM ;
EOT;
	runquery($add);
	$query = $DB->query("SELECT cid, name, url, displayorder FROM {$db_prefix}categories");
	while ($cate = $DB->fetch_array($query)) {
		$DB->query("INSERT INTO {$db_prefix}metas (name, slug, type, displayorder) VALUES ('".addslashes($cate['name'])."', '".addslashes($cate['url'])."', 'category', '".addslashes($cate['displayorder'])."')");
		$mid = $DB->insert_id();

		$articles = $DB->query("SELECT articleid, visible FROM {$db_prefix}articles WHERE cid='".$cate['cid']."'");
		while ($article = $DB->fetch_array($articles)) {
			$r  = $DB->fetch_one_array("SELECT cid FROM {$db_prefix}relationships WHERE mid='$mid' AND cid='".$article['articleid']."' LIMIT 1");
			if (!$r) {
				$DB->query("INSERT INTO {$db_prefix}relationships (cid,mid) VALUES ('".$article['articleid']."', '$mid')");
			}
			if ($article['visible']) {
				$DB->unbuffered_query("UPDATE {$db_prefix}metas SET count=count+1 WHERE mid='$mid' AND type='category'");
			}
		}
	}
	//$DB->query("DROP TABLE {$db_prefix}categories");
	$DB->unbuffered_query("ALTER TABLE {$db_prefix}articles CHANGE attachments attachments tinyint NOT NULL DEFAULT '0'");

	echo '<div class="install_main">';
	echo '<p class="p2">成功重建所有分类数据</p><p class="p2"><a href="'.$php_self.'?action=second">程序将自动跳转.如果没有自动跳转,请点击这里.</a></p>';
	echo '<meta HTTP-EQUIV="REFRESH" content="3;URL='.$php_self.'?action=second">';
	echo '</div></body></html>';
	exit;
} elseif ($action == 'second') {
	$query = $DB->query("SELECT articleid, keywords, visible FROM {$db_prefix}articles LIMIT $start, $percount");
	while($article = $DB->fetch_array($query)){
		$goon = 1;
		//关联标签
		if ($article['keywords']) {
			$tagdb = explode(',', $article['keywords']);
			foreach($tagdb as $tag) {
				$tag = sax_addslashes(trim($tag));
				if ($tag) {
					$r = $DB->fetch_one_array("SELECT mid FROM {$db_prefix}metas WHERE name='$tag' AND type='tag' LIMIT 1");
					if(!$r) {
						$DB->query("INSERT INTO {$db_prefix}metas (name,slug,type) VALUES ('$tag', '$tag', 'tag')");
						$mid = $DB->insert_id();
						$DB->query("INSERT INTO {$db_prefix}relationships (cid,mid) VALUES ('".$article['articleid']."', '$mid')");
					} else {
						$mid = $r['mid'];
						$r2  = $DB->fetch_one_array("SELECT cid FROM {$db_prefix}relationships WHERE mid='$mid' AND cid='".$article['articleid']."' LIMIT 1");
						if (!$r2) {
							$DB->query("INSERT INTO {$db_prefix}relationships (cid,mid) VALUES ('".$article['articleid']."', '$mid')");
						}
					}					
					if ($article['visible']) {
						$DB->unbuffered_query("UPDATE {$db_prefix}metas SET count=count+1 WHERE mid='$mid' AND type='tag'");
					}
				}
			}
		}		
		$attach_total = $DB->result($DB->query("SELECT COUNT(attachmentid) FROM {$db_prefix}attachments WHERE articleid='".$article['articleid']."'"), 0);
		$DB->unbuffered_query("UPDATE {$db_prefix}articles SET attachments='$attach_total' WHERE articleid='".$article['articleid']."'");
	}
	echo '<div class="install_main">';
	if($goon) {
		echo '<p class="p2">文章中的数据正在更新 '.$start.' 到 '.$next.' 项</p><p class="p2"><a href="'.$jumpurl.'">程序将自动跳转.如果没有自动跳转,请点击这里.</a></p>';
		echo '<meta HTTP-EQUIV="REFRESH" content="3;URL='.$jumpurl.'">';
	} else {
		echo '<p class="p2">成功重建所有文章内的数据</p><p class="p2"><a href="'.$php_self.'?action=second">程序将自动跳转.如果没有自动跳转,请点击这里.</a></p>';
		echo '<meta HTTP-EQUIV="REFRESH" content="3;URL='.$php_self.'?action=three">';
	}
	echo '</div></body></html>';
	exit;
} elseif ($action == 'three') {
$sql = <<<EOT
ALTER TABLE {$db_prefix}articles DROP cid, DROP keywords;

ALTER TABLE {$db_prefix}statistics DROP user_count ;

ALTER TABLE {$db_prefix}statistics DROP attachment_count ;


ALTER TABLE {$db_prefix}links DROP displayorder ;

ALTER TABLE {$db_prefix}links ADD home TINYINT( 1 ) NOT NULL DEFAULT '0';

DELETE FROM {$db_prefix}settings WHERE title = 'sidebarlink_num' LIMIT 1;
DELETE FROM {$db_prefix}settings WHERE title = 'random_links' LIMIT 1;
DELETE FROM {$db_prefix}settings WHERE title = 'show_links' LIMIT 1;
DELETE FROM {$db_prefix}settings WHERE title = 'archives_num' LIMIT 1;
EOT;
	runquery($sql);
	echo '<p class="p2">更新数据结构成功</p>';
} else {
?>
<div class="install_main">
  <div id="install_innertext">
    <p class="p2">感谢您选择由 <a href="http://www.4ngel.net/" target="_blank">安全天使网络安全小组</a> 开发的 <a href="http://www.4ngel.net/">SaBlog-X</a> 博客程序!</p>
    <p class="p2">当前版本为 <u>SaBlog-X v 1.6</u></p>
    <p class="p2">目标版本为 <u>SaBlog-X v 2.0</u></p>
    <p class="p2">升级过程完全不用人工干预,请耐心等待成功带来的喜悦.</p>
	<p class="p2"><a href="<?=$php_self?>?action=first">升级数据</a></p>
  </div>
</div>
<?php
}
?>
<div class="copyright">Powered by SaBlog-X (C) 2003-2006 Security Angel Team</div>
</body>
</html>
